<?xml version="1.0"?>
<!--
	The lestes compiler suite
	Copyright (C) 2002, 2003, 2004, 2005 Miroslav Tichy
	Copyright (C) 2002, 2003, 2004, 2005 Petr Zika
	Copyright (C) 2002, 2003, 2004, 2005 Vojtech Hala
	Copyright (C) 2002, 2003, 2004, 2005 Jiri Kosina
	Copyright (C) 2002, 2003, 2004, 2005 Pavel Sanda
	Copyright (C) 2002, 2003, 2004, 2005 Jan Zouhar
	Copyright (C) 2002, 2003, 2004, 2005 Rudolf Thomas

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; version 2 of the License.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	See the full text of the GNU General Public License version 2, and
	the limitations in the file doc/LICENSE.

	By accepting the license the licensee waives any and all claims
	against the copyright holder(s) related in whole or in part to the
	work, its use, and/or the inability to use it.
-->
<!DOCTYPE xsl:transform [
	<!ENTITY nl "&#x0A;">
	<!ENTITY tab "&#x09;">
]>
<xsl:transform version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:lsd="http://lestes.jikos.cz/schemas/lsd"
 xmlns:lvd="http://lestes.jikos.cz/schemas/lvd"
 xmlns="http://lestes.jikos.cz/schemas/lsd"
 xmlns:h="http://www.w3.org/TR/REC-html40">
	<!-- Generate abstract class for each visitor. -->
	<xsl:output method="xml"/>

	<xsl:template match="/lvd:lvd">
		<lsd xmlns="http://lestes.jikos.cz/schemas/lsd">
			<xsl:text>&nl;&tab;</xsl:text>
			<xsl:element name="comment">This file is automatically generated, do not edit.</xsl:element>
			<xsl:text>&nl;</xsl:text>
			<xsl:apply-templates />
		</lsd>
	</xsl:template>
	
	<xsl:template match="*">
		<xsl:element name="{name()}">
			<xsl:apply-templates select="@*" />
			<xsl:apply-templates />
		</xsl:element>
	</xsl:template>

<!--	<xsl:template match="/lvd:lvd/lvd:uses">
<xsl:message><xsl:value-of select="concat('uses/@href: ',@href,'&nl;')"/></xsl:message>
	</xsl:template>
-->

	<xsl:template match="/lvd:lvd/lvd:uses">
		<xsl:element name="include">
			<xsl:apply-templates select="@*" />
			<xsl:apply-templates />
		</xsl:element>
		<xsl:text>&nl;</xsl:text>
		<xsl:apply-templates mode="foreign-classes" select="document(@href,.)/lsd:lsd/lsd:class" />
		<xsl:apply-templates select="document(@href,.)/lsd:lsd/lsd:include" />
	</xsl:template>

	<xsl:template match="/lsd:lsd/lsd:include">
		<xsl:apply-templates mode="foreign-classes" select="document(@href,.)/lsd:lsd/lsd:class" />
		<xsl:apply-templates select="document(@href,.)/lsd:lsd/lsd:include" />
	</xsl:template>

	<xsl:template match="@*">
		<xsl:attribute name="{name()}">
			<xsl:apply-templates />
		</xsl:attribute>
	</xsl:template>

	<xsl:template match="text()">
		<xsl:value-of select="." />
	</xsl:template>

	<xsl:template match="/lvd:lvd/lvd:visitors">
		<!-- do not copy the elements themselves, just process the contents -->
		<xsl:apply-templates />
	</xsl:template>

	<xsl:template match="/lvd:lvd/lvd:file-name/text()">
		<xsl:value-of select="concat(.,'.v')" />
	</xsl:template>
	
	<xsl:template match="/lvd:lvd/lvd:visitors/lvd:v">
		<!-- remember the visitor's name -->
		<xsl:variable name="name" select="@name"/>
		<xsl:variable name="doc">
			<!-- the document, where is the base class, containing the visitor -->
			<xsl:call-template name="get-doc">
				<xsl:with-param name="name" select="$name"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="class">
			<!-- name of the base class, containing the visitor -->
			<xsl:call-template name="get-class">
				<xsl:with-param name="name" select="$name"/>
				<xsl:with-param name="doc" select="$doc"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="type">
			<!-- visitor's return type -->
			<xsl:call-template name="get-type">
				<xsl:with-param name="name" select="$name"/>
				<xsl:with-param name="doc" select="$doc"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:element name="class">
			<xsl:attribute name="name"><xsl:value-of select="$name" /></xsl:attribute>
			<xsl:attribute name="base">::lestes::std::visitor_base</xsl:attribute>
			<xsl:attribute name="abstract">yes</xsl:attribute>
			<!-- copy the dox -->
			<xsl:apply-templates select="lvd:dox" />

			<xsl:for-each select="/lvd:lvd/lvd:uses">
				<xsl:apply-templates mode="visit-decl" select="document(@href,.)/lsd:lsd/lsd:class[ string(@abstract) != 'yes' ]">
					<!-- for all non-abstract classes -->
					<xsl:with-param name="visitor-name" select="$name"/>
					<xsl:with-param name="visitor-type" select="$type"/>
				</xsl:apply-templates>
			</xsl:for-each>
			<xsl:text>&nl;&tab;</xsl:text>
		</xsl:element>
		<!-- the special ones -->
		<xsl:for-each select="./lvd:special">
			<xsl:variable name="special-name" select="@name"/>
			<xsl:text>&nl;&tab;</xsl:text>
			<xsl:element name="class">
				<xsl:attribute name="name">
					<xsl:value-of select="$special-name" />
				</xsl:attribute>
				<xsl:attribute name="base">
					<xsl:value-of select="$name" />
				</xsl:attribute>
				<xsl:attribute name="abstract">yes</xsl:attribute>
				<xsl:for-each select="lvd:cut">
					<xsl:text>&nl;&tab;&tab;</xsl:text>
					<xsl:element name="method">
						<xsl:attribute name="specifier">virtual</xsl:attribute>
						<xsl:attribute name="type">
							<xsl:value-of select="$type" />
						</xsl:attribute>
						<xsl:attribute name="name">
							<xsl:value-of select="@method" />
						</xsl:attribute>
						<xsl:attribute name="qualifier">abstract</xsl:attribute>
						<xsl:element name="param">
							<xsl:attribute name="type">
								<xsl:value-of select="@at" />
							</xsl:attribute>
							<xsl:attribute name="name" />	<!-- deliberately empty -->
						</xsl:element>
					</xsl:element>
				</xsl:for-each>
				<xsl:for-each select="lvd:cut">
					<xsl:variable name="at" select="@at"/>
					<xsl:variable name="method" select="@method"/>
					<xsl:for-each select="/lvd:lvd/lvd:uses">
						<xsl:apply-templates mode="visit-decl-special" select="document(@href,.)/lsd:lsd/lsd:class[ string(@abstract) != 'yes' ]">
							<!-- for all non-abstract classes -->
							<xsl:with-param name="visitor-name" select="$name"/>
							<xsl:with-param name="visitor-type" select="$type"/>
							<xsl:with-param name="cut-class" select="$at"/>
						</xsl:apply-templates>
					</xsl:for-each>
				</xsl:for-each>
				<xsl:text>&nl;&tab;</xsl:text>
			</xsl:element>
		</xsl:for-each>
	</xsl:template>

	<xsl:template mode="visit-decl" match="lsd:class">
		<xsl:param name="visitor-name"/>
		<xsl:param name="visitor-type"/>
		<xsl:variable name="haveit">
			<xsl:apply-templates mode="visitor-present" select=".">
				<xsl:with-param name="name" select="$visitor-name"/>
			</xsl:apply-templates>
		</xsl:variable>
		<xsl:if test="$haveit = 'yes'">
			<xsl:text>&nl;&tab;&tab;</xsl:text>
			<xsl:element name="method">
				<xsl:attribute name="specifier">virtual</xsl:attribute>
				<xsl:attribute name="type">
					<xsl:value-of select="$visitor-type" />
				</xsl:attribute>
				<xsl:attribute name="name">
					<xsl:value-of select="concat('visit_',@name)" />
				</xsl:attribute>
				<xsl:attribute name="qualifier">abstract</xsl:attribute>
				<xsl:element name="param">
					<xsl:attribute name="type">
						<xsl:value-of select="@name" />
					</xsl:attribute>
					<xsl:attribute name="name" />	<!-- deliberately empty -->
				</xsl:element>
			</xsl:element>
		</xsl:if>
	</xsl:template>

	<xsl:template mode="visit-decl-special" match="lsd:class">
		<xsl:param name="visitor-name"/>
		<xsl:param name="visitor-type"/>
		<xsl:param name="cut-class"/>
		<xsl:variable name="haveit">
			<xsl:apply-templates mode="visitor-present" select=".">
				<xsl:with-param name="name" select="$visitor-name"/>
			</xsl:apply-templates>
		</xsl:variable>
		<xsl:variable name="undercut">
			<xsl:apply-templates mode="under-cut" select=".">
				<xsl:with-param name="cut-class" select="$cut-class"/>
			</xsl:apply-templates>
		</xsl:variable>
		<xsl:if test="($haveit = 'yes') and ($undercut = 'yes')">
			<xsl:text>&nl;&tab;&tab;</xsl:text>
			<xsl:element name="method">
				<xsl:attribute name="specifier">virtual</xsl:attribute>
				<xsl:attribute name="type">
					<xsl:value-of select="$visitor-type" />
				</xsl:attribute>
				<xsl:attribute name="name">
					<xsl:value-of select="concat('visit_',@name)" />
				</xsl:attribute>
				<xsl:element name="param">
					<xsl:attribute name="type">
						<xsl:value-of select="@name" />
					</xsl:attribute>
					<xsl:attribute name="name" />	<!-- deliberately empty -->
				</xsl:element>
			</xsl:element>
		</xsl:if>
	</xsl:template>

	<xsl:template mode="foreign-classes" match="lsd:class">
		<xsl:text>&tab;</xsl:text>
		<xsl:element name="foreign-class">
			<xsl:attribute name="name">
				<xsl:value-of select="@name" />
			</xsl:attribute>
			<!-- copy the <p> tags... -->
			<xsl:apply-templates select="../lsd:packages/lsd:p" />
			<!--
			<xsl:attribute name="packages">
				<xsl:for-each select="../lsd:packages/lsd:p">
					<xsl:value-of select="concat('::',text())" />
				</xsl:for-each>
				<xsl:text>::</xsl:text>
			</xsl:attribute>
			-->
		</xsl:element>
		<xsl:text>&nl;</xsl:text>
	</xsl:template>

	<xsl:include href="lvd_common.xslt" />

</xsl:transform>
